
package de.ivu.elect.business.gebietsbaum.boundary;

import javax.inject.Inject;

import de.ivu.elect.business.gebietsbaum.entity.Gebietsart;

// abgeleitete Klasse mit "@javax.ejb.Stateless" annotieren!
public abstract class AbstractGebietsartEdit {

  @Inject
  protected GebietsartDAO dao;

  @Inject
  protected GebietsartExtendedDAO extendedDao;

  public void delete(Gebietsart entity) {
    dao.remove(getAttachedEntity(entity));
  }

  public void save(Gebietsart entity) {
    validate(entity);

    flushToSave();
  }

  protected void validate(Gebietsart entity) {
    // Do nothing by default.
  }

  protected void flushToSave() {
    if(usesMixedTransactionalContexts()) {
        extendedDao.flushNewTransaction();
    } else {
        extendedDao.flush();
    }
  }

  // ELECT-945
  protected boolean usesMixedTransactionalContexts() {
    return false;
  }

  protected Gebietsart getAttachedEntity(Gebietsart entity) {
    return dao.findByPrimaryKey(entity.getPk());
  }

  // Cf. ELECT-3187 (Änderungen an Entität werden nicht gespeichert)
  protected Gebietsart getAttachedAndRefreshedEntity(Gebietsart entity) {
    return dao.refresh(entity);
  }
}
